// Code generated by mockery v2.20.0. DO NOT EDIT.

package mockclients

import (
	context "context"
	io "io"

	mock "github.com/stretchr/testify/mock"

	types "gitlab.com/infor-cloud/martian-cloud/tharsis/tharsis-sdk-go/pkg/types"
)

// TerraformModuleVersion is an autogenerated mock type for the TerraformModuleVersion type
type TerraformModuleVersion struct {
	mock.Mock
}

// CreateModuleVersion provides a mock function with given fields: ctx, input
func (_m *TerraformModuleVersion) CreateModuleVersion(ctx context.Context, input *types.CreateTerraformModuleVersionInput) (*types.TerraformModuleVersion, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.TerraformModuleVersion
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateTerraformModuleVersionInput) (*types.TerraformModuleVersion, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateTerraformModuleVersionInput) *types.TerraformModuleVersion); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.TerraformModuleVersion)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.CreateTerraformModuleVersionInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteModuleVersion provides a mock function with given fields: ctx, input
func (_m *TerraformModuleVersion) DeleteModuleVersion(ctx context.Context, input *types.DeleteTerraformModuleVersionInput) error {
	ret := _m.Called(ctx, input)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.DeleteTerraformModuleVersionInput) error); ok {
		r0 = rf(ctx, input)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetModuleVersion provides a mock function with given fields: ctx, input
func (_m *TerraformModuleVersion) GetModuleVersion(ctx context.Context, input *types.GetTerraformModuleVersionInput) (*types.TerraformModuleVersion, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.TerraformModuleVersion
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetTerraformModuleVersionInput) (*types.TerraformModuleVersion, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetTerraformModuleVersionInput) *types.TerraformModuleVersion); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.TerraformModuleVersion)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetTerraformModuleVersionInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetModuleVersions provides a mock function with given fields: ctx, input
func (_m *TerraformModuleVersion) GetModuleVersions(ctx context.Context, input *types.GetTerraformModuleVersionsInput) (*types.GetTerraformModuleVersionsOutput, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.GetTerraformModuleVersionsOutput
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetTerraformModuleVersionsInput) (*types.GetTerraformModuleVersionsOutput, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetTerraformModuleVersionsInput) *types.GetTerraformModuleVersionsOutput); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.GetTerraformModuleVersionsOutput)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetTerraformModuleVersionsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UploadModuleVersion provides a mock function with given fields: ctx, moduleVersionID, reader
func (_m *TerraformModuleVersion) UploadModuleVersion(ctx context.Context, moduleVersionID string, reader io.Reader) error {
	ret := _m.Called(ctx, moduleVersionID, reader)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, string, io.Reader) error); ok {
		r0 = rf(ctx, moduleVersionID, reader)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

type mockConstructorTestingTNewTerraformModuleVersion interface {
	mock.TestingT
	Cleanup(func())
}

// NewTerraformModuleVersion creates a new instance of TerraformModuleVersion. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewTerraformModuleVersion(t mockConstructorTestingTNewTerraformModuleVersion) *TerraformModuleVersion {
	mock := &TerraformModuleVersion{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
